package App::Clifton::ConfigLoader;

use aliased 'App::Clifton::Config';
use aliased 'App::Clifton::UserConfig';
use Config::Settings;
use Moo;

has _cs => (is => 'lazy', handles => { '_parse_file' => 'parse_file' });

sub _build__cs {
  Config::Settings->new
}

sub _new_config { Config->new }

sub config_from_file {
  my ($self, $file) = @_;
  my $data = $self->_parse_file($file);
  my $config = $self->_new_config;
  foreach my $name (keys %{$data->{bridge}}) {
    $config->bridges->add({
      name => $name,
      %{$data->{bridge}{$name}}
    });
  }
  foreach my $name (keys %{$data->{user}}) {
    $config->users->add({
      name => $name,
      %{$data->{user}{$name}}
    });
  }
  return $config;
}
